/*

 Copyright (c) [2023] [pcm]
 [pcm-coordinator] is licensed under Mulan PSL v2.
 You can use this software according to the terms and conditions of the Mulan PSL v2.
 You may obtain a copy of Mulan PSL v2 at:
          http://license.coscl.org.cn/MulanPSL2
 THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
 EITHER EXPaRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
 MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
 See the Mulan PSL v2 for more details.

*/

package ai

import (
	"context"
	"github.com/pkg/errors"
	"github.com/zeromicro/go-zero/core/logx"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/participant"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	dataset "gitlink.org.cn/JointCloud/pcm-coordinator/internal/types/ai"
	"net/http"
)

type CreateDataSetLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCreateDataSetLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateDataSetLogic {
	return &CreateDataSetLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateDataSetLogic) CreateDataSet(req *dataset.CreateDatasetReq) (resp interface{}, err error) {
	param := &participant.CreateParam{
		Name:  req.Name,
		Desc:  req.Desc,
		Src:   req.Src,
		Param: req.Param,
	}
	create, err := l.svcCtx.Ai.DatasetCreateById(req.ClusterId, param)
	if err != nil {
		return nil, err
	}
	if create.Code != http.StatusOK {
		return nil, errors.New(create.Message)
	}
	resp = create.Data
	return

}
